<?php
$input=REST::input();
$method=REST::getMethod();
if($input->getPart()=='') {
	switch ($method) {
		case REST::get: //List
			$q=$local_connection->query('SELECT `GUID`,`username` FROM `users`');
			while($r=$q->fetch_assoc()) {
				REST::output()->appendData($r);
			}
			break;
		case REST::put: //Create new
			auth::init();
			auth::granted(auth::all,true);
			if(!session::isAdmin()) throw new UnauthorizedException('You need admin privileges to create a user');
			$data=$input->getData();
			if(!isset($data['username'],$data['password'],$data['email'])) throw new BadRequestException('Please provide username, password and email parameters');
			if(session::register($data['username'], $data['password'], $data['email'])) {
				REST::output()->setData(array('status'=>true,'errors'=>array()));
				REST::success(201);
			}
			else {
				$errors=JSError::get();
				REST::output()->setData(array('status'=>false,'errors'=>$errors));
			}
			break;
		default:
			throw new MethodNotAllowedException('Invalid method for "'.$input->getPart().'" on "'.$input->getModule().'"');
	}
}
else if(strlen($input->getPart())==36&&preg_match('/^[0-9A-F]{8}-([0-9A-F]{4}-){3}[0-9A-F]{12}$/i', $input->getPart())) { //User by guid
	switch ($method) {
		case REST::get: //Show user info
			auth::init();
			$q=$local_connection->query('SELECT `GUID`,`username` FROM `users` WHERE `GUID`=\''.$local_connection->escape_string($input->getPart()).'\'');
			if($q->num_rows!=1) throw new NotFoundException('This user does not exist');
			$data=$q->fetch_assoc();
			REST::output()->setData($data);
		break;
		case REST::delete: //Delete this user
			auth::init();
			auth::granted(auth::all,true);
			if(!session::isAdmin()) throw new UnauthorizedException('You need admin privileges to delete a user');
			$q=$local_connection->query('DELETE FROM `users` WHERE `GUID`=\''.$local_connection->escape_string($input->getPart().'\''));
			if($q) REST::output()->setData(array('status'=>true));
			else REST::output()->setData(array('status'=>false));
		default:
			throw new MethodNotAllowedException('Invalid method for "'.$input->getPart().'" on "'.$input->getModule().'"');
	}
}
elseif($input->getPart()=='search') {
	switch($method) {
		case REST::get:
			$data=$input->getData();
			if(!isset($data['username'])) $data['username']='';
			$q=$local_connection->query('SELECT `GUID`,`username` FROM `users` WHERE `username` LIKE \''.$local_connection->escape_string($data['username']).'\'');
			while($r=$q->fetch_assoc()){
				REST::output()->appendData($r);
			}
		break;
		default:
			throw new MethodNotAllowedException('Invalid method for "'.$input->getPart().'" on "'.$input->geModule().'"');
	}
}
elseif($input->getPart()=='me') {
	switch ($method) {
		case REST::get: //Show user info
			auth::init();
			$mail=auth::granted(auth::read_mail_addr);
			$lang=auth::granted(auth::read_lang);
			$q=$local_connection->query('SELECT `GUID`,`username`'.($mail?',`email`':'').($lang?',`lang`':'').' FROM `users` WHERE `GUID`=\''.$local_connection->escape_string(session::$guid).'\'');
			if($q->num_rows!=1) throw new GoneException('Authenticated user no longer exists');
			$data=$q->fetch_assoc();
			if(isset($data['lang'])) $data['lang']=unserialize($data['lang']);
			REST::output()->setData($data);
		break;
		case REST::post: //Update user info
			auth::init();
			auth::granted(auth::write_lang,true);
			$data=$input->getData();
			if(!isset($data['lang'])) throw new BadRequestException('Please provide lang parameter');
			$data['lang']=(REST::getDataType()==REST::json?json_decode($data['lang']):unserialize($data['lang']));
			if(!is_array($data['lang'])) throw new BadRequestException('Please provide a valid lang parameter');
			$q=$local_connection->query('UPDATE `users` SET `lang`=\''.serialize($data['lang']).'\' WHERE `GUID`=\''.$local_connection->escape_string(session::$guid).'\'');
			if($q) {
				REST::output()->setData(array('status'=>true));
			}
			else {
				REST::output()->setData(array('status'=>false));
			}
		break;
		default:
			throw new MethodNotAllowedException('Invalid method for "'.$input->getPart().'" on "'.$input->getModule().'"');
	}
}
else {
	throw new NotImplementedException('"'.$input->getPart().'" is not implemented in the module "'.$input->getModule().'"');
}